#pragma once

namespace ADSLibrary
{
	namespace DataStructures
	{
		namespace LinkedStructures
		{
			namespace OOP
			{
				/**
				 * \brief Zsobnk implementovan pomoc spojovch struktur s vyuitm %OOP.
				 *
				 * @author	Ji Dvorsk <jiri.dvorsky@vsb.cz>
				 * @date	2010 - 2015
				 */
				class Stack
				{
				public:
					/**
					 * Konstruktor.
					 */
					Stack();

					/**
					 * Destruktor.
					 */
					~Stack();

					/**
					 * Vloen prvku na vrchol zsobnku.
					 *
					 * @param X Vkldan prvek
					 */
					void Push(const char X);

					/**
					 * Odebrn prvku z vrcholu zsobnku.
					 *
					 * @return Prvek z vrcholu zsobnku
					 */
					char Pop();

					/**
					 * Prvek na vrcholu zsobnku.
					 * Prvek nen za zsobnku odstrann, jedn se tedy o nedestruktivn variantu funkce #Pop.
					 *
					 * @return Prvek z vrcholu zsobnku
					 */
					char Top() const;

					/**
					 * Test, je-li zsobnk przdn.
					 *
					 * @return Funkce vrac true pokud je zsobnk przdn, jinak false.
					 */
					bool IsEmpty() const;
				
					/**
					 * Smazn celho obsahu zsobnku.
					 */
					void Clear();

				private:
					/**
					 * \brief Struktura reprezentujc poloku v zsobnku.
					 */
					struct StackItem
					{
						/**
						 * Hodnota obsaen v poloce.
						 */
						char Value;
						/**
						 * Ukazatel na pedchoz poloku. Pokud takov poloka neexistuje ukazatel m hodnotu nullptr.
						 */
						StackItem* Prev;
					};

					/**
					 * Ukazatel zsobnku.
					 */
					StackItem* StackPointer;
				};
			}
		}
	}
}